## libscrypt 1

=== Makefile ===
CC=gcc
CFLAGS=-O2 -Wall -g -D_FORTIFY_SOURCE=2 -fstack-protector -fPIC
all: reference

OBJS= crypto_scrypt-nosse.o sha256.o crypto_scrypt-hexconvert.o crypto-mcf.o modp_b64.o crypto-scrypt-saltgen.o crypto_scrypt-check.o crypto_scrypt-hash.o


library: $(OBJS)
	$(CC) -shared -Wl,-soname,libscrypt.so.0 -Wl,--version-script=libscrypt.version -o libscrypt.so.0 -lc  $(OBJS)
	ar rcs libscrypt.a  $(OBJS)

reference: library main.o
	ln -s -f libscrypt.so.0 libscrypt.so
	$(CC) -Wall -o reference main.o -Wl,-rpath=. -L.  -lm  -lscrypt

clean:
	rm -f *.o reference libscrypt.so* libscrypt.a

check: all
	./reference

devtest:
	splint crypto_scrypt-hexconvert.c 
	splint crypto-mcf.c crypto_scrypt-check.c crypto_scrypt-hash.c
	splint crypto-scrypt-saltgen.c +posixlib
	valgrind ./reference

install: library
	install -m 0644 libscrypt.a $(DESTDIR)/usr/local/lib
	install -m 0644 libscrypt.so.0 $(DESTDIR)/usr/local/lib
	ln -s -f $(DESTDIR)/usr/local/lib/libscrypt.so.0 $(DESTDIR)/usr/local/lib/libscrypt.so
	install -m 0644 libscrypt.h  $(DESTDIR)/usr/local/include

=== debian/changelog ===
libscrypt (1-2ubuntu2) trusty; urgency=low

  * debian/patches/big-endian.patch: Fix compilation on big-endian arches.

 -- Adam Conrad <adconrad@ubuntu.com>  Wed, 30 Oct 2013 16:26:03 -0600

libscrypt (1-2ubuntu1) trusty; urgency=low

  * debian/patches/math-linking.patch: fix linking with -lm for crypto-mcf.

 -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Tue, 29 Oct 2013 21:49:27 -0700

libscrypt (1-2) unstable; urgency=low

  * Add missing BSD-3-clause license to debian/copyright

 -- Micah Anderson <micah@debian.org>  Tue, 13 Aug 2013 09:42:28 -0400

libscrypt (1-1) unstable; urgency=low

  * Initial release (Closes: #713913)

 -- Micah Anderson <micah@debian.org>  Sun, 23 Jun 2013 15:59:17 -0400

=== debian/control ===
Source: libscrypt
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Micah Anderson <micah@debian.org>
Build-Depends: debhelper (>= 9)
Standards-Version: 3.9.4
Section: libs
Homepage: http://www.lolware.net/libscrypt.html
Vcs-Git: git://git.debian.org/collab-maint/libscrypt.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/libscrypt.git;a=summary

Package: libscrypt-dev
Section: libdevel
Architecture: any
Depends: libscrypt0 (= ${binary:Version}), ${misc:Depends}
Description: scrypt shared library - development files
 The scrypt algorithm is a password-based key derivation function
 designed to require large amounts of memory. This proof-of-work scheme
 is intended to make it costly to perform large-scale hardware
 attacks.
 . 
 This package contains a shared library implementing the scrypt
 algorithm, based on the original implementation with a number of
 harnesses and simplified interfaces.

Package: libscrypt0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: scrypt shared library
 The scrypt algorithm is a password-based key derivation function
 designed to require large amounts of memory. This proof-of-work scheme
 is intended to make it costly to perform large-scale hardware
 attacks.
 . 
 This package contains a shared library implementing the scrypt
 algorithm, based on the original implementation with a number of
 harnesses and simplified interfaces.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

%:
	dh $@ 

override_dh_auto_install:
	$(MAKE) DESTDIR=debian/tmp PREFIX=/usr install

=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3

# Uncomment to examine a Webpage
# <Webpage URL> <string match>
http://www.lolware.net/libscrypt.html http://www.lolware.net/libscrypt-stable(.*?).tar.gz

## libscrypt 1.20

=== debian/changelog ===
libscrypt (1.20-1) experimental; urgency=low

  * ACK NMUs, thanks for the fixes.
  * New upstream release (Closes: #746041).
    - Drop patches from NMUs due to inclusion of equivalent changes upstream.
  * Add myself as co-maintainer.
  * Bump Standards-Version.
  * Add a symbols file.
  * Tweak -dev package description.
  * Update Vcs-* fields.
  * Update copyright file.

 -- Tristan Seligmann <mithrandi@debian.org>  Sun, 14 Dec 2014 05:28:49 +0200

libscrypt (1-2.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS on big endian architecture.
    Patch by Aurelien Jarno.
    Add big-endian.patch.
    Closes: #728254.

 -- Anibal Monsalve Salazar <anibal@debian.org>  Mon, 21 Jul 2014 06:32:03 +0100

libscrypt (1-2.1) unstable; urgency=medium

  * Non-maintainer upload
  * Make symlink relative (Closes: #731174)

 -- David Prévot <taffit@debian.org>  Wed, 25 Dec 2013 20:48:11 -0400

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,13 @@
 Source: libscrypt
 Priority: extra
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Micah Anderson <micah@debian.org>
+Maintainer: Micah Anderson <micah@debian.org>
+Uploaders: Tristan Seligmann <mithrandi@debian.org>
 Build-Depends: debhelper (>= 9)
-Standards-Version: 3.9.4
+Standards-Version: 3.9.6
 Section: libs
 Homepage: http://www.lolware.net/libscrypt.html
-Vcs-Git: git://git.debian.org/collab-maint/libscrypt.git
-Vcs-Browser: http://git.debian.org/?p=collab-maint/libscrypt.git;a=summary
+Vcs-Git: git://anonscm.debian.org/collab-maint/libscrypt.git
+Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/libscrypt.git;a=summary
 
 Package: libscrypt-dev
 Section: libdevel
@@ -19,12 +19,9 @@
  is intended to make it costly to perform large-scale hardware
  attacks.
  . 
- This package contains a shared library implementing the scrypt
- algorithm, based on the original implementation with a number of
- harnesses and simplified interfaces.
+ This package contains files for development with libscrypt.
 
 Package: libscrypt0
-Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: scrypt shared library

## libscrypt 1.21

=== Makefile ===
PREFIX       ?= /usr/local
LIBDIR       ?= $(PREFIX)/lib
INCLUDEDIR   ?= $(PREFIX)/include
MAKE_DIR     ?= install -d
INSTALL_DATA ?= install

CC?=gcc
CFLAGS?=-O2 -Wall -g -D_FORTIFY_SOURCE=2 -fstack-protector -fPIC
LDFLAGS?=-Wl,-z,now -Wl,-z,relro -Wl,-soname,libscrypt.so.0 -Wl,--version-script=libscrypt.version
CFLAGS_EXTRA?=-Wl,-rpath=.

all: reference

OBJS= crypto_scrypt-nosse.o sha256.o crypto-mcf.o b64.o crypto-scrypt-saltgen.o crypto_scrypt-check.o crypto_scrypt-hash.o slowequals.o

libscrypt.so.0: $(OBJS) 
	$(CC)  $(LDFLAGS) -shared -o libscrypt.so.0  $(OBJS) -lm -lc
	ar rcs libscrypt.a  $(OBJS)

reference: libscrypt.so.0 main.o crypto_scrypt-hexconvert.o
	ln -s -f libscrypt.so.0 libscrypt.so
	$(CC) -Wall -o reference main.o b64.o crypto_scrypt-hexconvert.o $(CFLAGS_EXTRA) -L.  -lscrypt

clean:
	rm -f *.o reference libscrypt.so* libscrypt.a endian.h

check: all
	./reference

devtest:
	splint crypto_scrypt-hexconvert.c 
	splint crypto-mcf.c crypto_scrypt-check.c crypto_scrypt-hash.c -unrecog
	splint crypto-scrypt-saltgen.c +posixlib -compdef
	valgrind ./reference

asan: main.c
	clang -O1 -g -fsanitize=address -fno-omit-frame-pointer  *.c -o asantest
	./asantest
	scan-build clang -O1 -g -fsanitize=undefined -fno-omit-frame-pointer  *.c -o asantest
	./asantest
	rm -f asantest

install: libscrypt.so.0
	$(MAKE_DIR) $(DESTDIR) $(DESTDIR)$(PREFIX) $(DESTDIR)$(LIBDIR) $(DESTDIR)$(INCLUDEDIR)
	$(INSTALL_DATA) -pm 0755 libscrypt.so.0 $(DESTDIR)$(LIBDIR)
	cd $(DESTDIR)$(LIBDIR) && ln -s -f libscrypt.so.0 $(DESTDIR)$(LIBDIR)/libscrypt.so
	$(INSTALL_DATA) -pm 0644 libscrypt.h  $(DESTDIR)$(INCLUDEDIR)

install-osx: libscrypt.so.0
	$(MAKE_DIR) $(DESTDIR) $(DESTDIR)$(PREFIX) $(DESTDIR)$(LIBDIR) $(DESTDIR)$(INCLUDEDIR)
	$(INSTALL_DATA) -pm 0755 libscrypt.so.0 $(DESTDIR)$(LIBDIR)/libscrypt.0.dylib
	cd $(DESTDIR)$(LIBDIR) && install_name_tool -id $(DESTDIR)$(LIBDIR)/libscrypt.0.dylib $(DESTDIR)$(LIBDIR)/libscrypt.0.dylib
	cd $(DESTDIR)$(LIBDIR) && ln -s -f libscrypt.0.dylib $(DESTDIR)$(LIBDIR)/libscrypt.dylib
	$(INSTALL_DATA) -pm 0644 libscrypt.h  $(DESTDIR)$(INCLUDEDIR)

install-static: libscrypt.a
	$(INSTALL_DATA) -pm 0644 libscrypt.a $(DESTDIR)$(LIBDIR)

=== debian/changelog ===
libscrypt (1.21-3) unstable; urgency=medium

  * Switch Vcs-Git to https.
  * Bump Standards-Version to 3.9.7 (no changes).
  * Fix trailing spaces in description.
  * Turn on all hardening options.

 -- Tristan Seligmann <mithrandi@debian.org>  Mon, 22 Feb 2016 02:14:56 +0200

libscrypt (1.21-2) unstable; urgency=medium

  * Version bump because of failed dgit upload.

 -- Tristan Seligmann <mithrandi@debian.org>  Fri, 07 Aug 2015 21:07:05 +0200

libscrypt (1.21-1) unstable; urgency=medium

  * Update debian/watch to point to Github.
  * New upstream release.

 -- Tristan Seligmann <mithrandi@debian.org>  Fri, 07 Aug 2015 21:00:05 +0200

libscrypt (1.20-2) unstable; urgency=medium

  * Reupload to unstable (no changes).

 -- Tristan Seligmann <mithrandi@debian.org>  Fri, 01 May 2015 01:32:55 +0200

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,11 @@
 Maintainer: Micah Anderson <micah@debian.org>
 Uploaders: Tristan Seligmann <mithrandi@debian.org>
 Build-Depends: debhelper (>= 9)
-Standards-Version: 3.9.6
+Standards-Version: 3.9.7
 Section: libs
 Homepage: http://www.lolware.net/libscrypt.html
-Vcs-Git: git://anonscm.debian.org/collab-maint/libscrypt.git
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/libscrypt.git;a=summary
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/libscrypt.git
+Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/libscrypt.git
 
 Package: libscrypt-dev
 Section: libdevel
@@ -18,7 +18,7 @@
  designed to require large amounts of memory. This proof-of-work scheme
  is intended to make it costly to perform large-scale hardware
  attacks.
- . 
+ .
  This package contains files for development with libscrypt.
 
 Package: libscrypt0
@@ -29,8 +29,7 @@
  designed to require large amounts of memory. This proof-of-work scheme
  is intended to make it costly to perform large-scale hardware
  attacks.
- . 
+ .
  This package contains a shared library implementing the scrypt
  algorithm, based on the original implementation with a number of
  harnesses and simplified interfaces.
-

=== debian/watch ===
version=3
https://github.com/technion/libscrypt/releases \
.*[^n]/(?:|v|version-|version|release-|r|REL_|rel-|libscrypt(?:_|-))(\d[^\s/]*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)

## libscrypt 1.22

=== Makefile ===
--- 
+++ 
@@ -5,27 +5,28 @@
 INSTALL_DATA ?= install
 
 CC?=gcc
-CFLAGS?=-O2 -Wall -g -D_FORTIFY_SOURCE=2 -fstack-protector -fPIC
-LDFLAGS?=-Wl,-z,now -Wl,-z,relro -Wl,-soname,libscrypt.so.0 -Wl,--version-script=libscrypt.version
-CFLAGS_EXTRA?=-Wl,-rpath=.
+CFLAGS?=$(CFLAGS_EXTRA) -D_FORTIFY_SOURCE=2 -fPIC
+LDFLAGS?=$(LDFLAGS_EXTRA) -Wl,-soname,libscrypt.so.0 -Wl,--version-script=libscrypt.version
+CFLAGS_EXTRA?=-Wl,-rpath=. -O2 -Wall -g -fstack-protector
+LDFLAGS_EXTRA?=-Wl,-z,relro
 
 all: reference
 
 OBJS= crypto_scrypt-nosse.o sha256.o crypto-mcf.o b64.o crypto-scrypt-saltgen.o crypto_scrypt-check.o crypto_scrypt-hash.o slowequals.o
 
 libscrypt.so.0: $(OBJS) 
-	$(CC)  $(LDFLAGS) -shared -o libscrypt.so.0  $(OBJS) -lm -lc
+	$(CC) $(LDFLAGS) -shared -o libscrypt.so.0  $(OBJS) -lm -lc
 	ar rcs libscrypt.a  $(OBJS)
 
 reference: libscrypt.so.0 main.o crypto_scrypt-hexconvert.o
 	ln -s -f libscrypt.so.0 libscrypt.so
-	$(CC) -Wall -o reference main.o b64.o crypto_scrypt-hexconvert.o $(CFLAGS_EXTRA) -L.  -lscrypt
+	$(CC) -o reference main.o b64.o crypto_scrypt-hexconvert.o $(CFLAGS) $(LDFLAGS_EXTRA) -L.  -lscrypt
 
 clean:
 	rm -f *.o reference libscrypt.so* libscrypt.a endian.h
 
 check: all
-	./reference
+	LD_LIBRARY_PATH=. ./reference
 
 devtest:
 	splint crypto_scrypt-hexconvert.c

=== debian/changelog ===
libscrypt (1.22-4) unstable; urgency=medium

  * Fix trailing-whitespace.
  * Add upstream/metadata.
  * Bump debian/* copyright years.
  * Adopt for pkg-security team.  Closes: #1092116.
  * Add lrc.excludes.
  * Run wrap-and-sort -satbk.
  * Add salsa-ci.

 -- Simon Josefsson <simon@josefsson.org>  Tue, 07 Oct 2025 18:54:51 +0200

libscrypt (1.22-3) unstable; urgency=medium

  * QA upload.
  * Add gbp.conf to make source maintainable with gbp.
  * Update debian/watch to version 5.
  * Bump Standards-Version to 4.7.2 (no changes).
  * Add github repo as Homepage for now.
  * Bump debhelper-compat to version 13.
  * Fix dep3 issues in hppa.patch.
  * Fix lintian issues on soname and blhc missing flag
  * Fix lintian issue symbols-file-missing-build-depends-package-field
  * Import upstream fixes for miscompilations and a FTBFS due to aliasing.

 -- Eduardo Barretto <eduardo.barretto@canonical.com>  Mon, 06 Oct 2025 14:19:59 +0000

libscrypt (1.22-2) unstable; urgency=medium

  * QA upload.
  * Fix build on hppa due to missing fPIC flag. (Closes: #1107632)

 -- Bastian Germann <bage@debian.org>  Thu, 28 Aug 2025 13:02:09 +0200

libscrypt (1.22-1) unstable; urgency=medium

  * QA upload.
  * Move from deprecated Priority: extra to optional.
  * Update debhelper-compat to 12.
  * lintian: insecure-copyright-format-uri.
  * Drop unnecessary libscrypt-dev.dirs.
  * Orphan package (see #1092116).
  * Drop invalid Homepage.

 -- Bastian Germann <bage@debian.org>  Sun, 23 Feb 2025 13:29:17 +0000

libscrypt (1.22-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * d/watch: Scan via GitHub API (Closes: #1061571).
  * New upstream release (Closes: #1061570).

 -- Bastian Germann <bage@debian.org>  Tue, 28 May 2024 21:45:33 +0200

libscrypt (1.21-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Migrate repository from alioth to salsa.
  * Remove retired uploader.

 -- Bastian Germann <bage@debian.org>  Thu, 13 Jul 2023 14:40:40 +0200

=== debian/control ===
Source: libscrypt
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders:
 Simon Josefsson <simon@josefsson.org>,
Build-Depends:
 debhelper-compat (= 13),
Standards-Version: 4.7.2
Section: libs
Homepage: https://github.com/technion/libscrypt
Vcs-Git: https://salsa.debian.org/debian/libscrypt.git
Vcs-Browser: https://salsa.debian.org/debian/libscrypt

Package: libscrypt-dev
Section: libdevel
Architecture: any
Depends:
 libscrypt0 (= ${binary:Version}),
 ${misc:Depends},
Description: scrypt shared library - development files
 The scrypt algorithm is a password-based key derivation function
 designed to require large amounts of memory. This proof-of-work scheme
 is intended to make it costly to perform large-scale hardware
 attacks.
 .
 This package contains files for development with libscrypt.

Package: libscrypt0
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: scrypt shared library
 The scrypt algorithm is a password-based key derivation function
 designed to require large amounts of memory. This proof-of-work scheme
 is intended to make it costly to perform large-scale hardware
 attacks.
 .
 This package contains a shared library implementing the scrypt
 algorithm, based on the original implementation with a number of
 harnesses and simplified interfaces.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_install:
	$(MAKE) DESTDIR=$(CURDIR)/debian/tmp PREFIX=/usr install install-static

=== debian/watch ===
Version: 5
Template: Github
Owner: technion
Project: libscrypt
